using System;

class Program
{
    struct SanteLeda
    {
        public int pocetnaSanta;
        public int krajnjaSanta;
        public bool prolaz;
    }
    static void Main()
    {
        string[] brojevi = Console.ReadLine().Split();
        int N = int.Parse(brojevi[0]);
        int M = int.Parse(brojevi[1]);

        SanteLeda[] santeLeda = new SanteLeda[M];
        for(int i = 0; i < M; i++)
        {
            string[] sante = Console.ReadLine().Split();
            santeLeda[i].pocetnaSanta = int.Parse(sante[0]);
            santeLeda[i].krajnjaSanta = int.Parse(sante[1]);
            santeLeda[i].prolaz = int.Parse(sante[2]) != 0;
        }

        string[] pozicije = Console.ReadLine().Split();
        int pocetnaPozicija = int.Parse(pozicije[0]);
        int krajnjaPozicija = int.Parse(pozicije[1]);
        bool stanje = false;
        int br = 0;
        while (krajnjaPozicija != pocetnaPozicija)
        {
            int i = 0;
            while(krajnjaPozicija != santeLeda[i].krajnjaSanta)
            {
                i++;
            }
            if (stanje != santeLeda[i].prolaz)
            {
                br += 2;
            }
            stanje = santeLeda[i].prolaz;
            krajnjaPozicija = santeLeda[i].pocetnaSanta;
        }
        Console.WriteLine(br);
        Console.ReadLine();
    }
}